<?php
/*
 * @version   3.0.11 Sun Mar 2 17:49:55 2014 -0800
 * @package   yoonique zoo element element plugin
 * @author    yoonique[.]net
 * @copyright Copyright (C) 2012 yoonique[.]net
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */


// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgContentYoonique_zooelement extends JPlugin {

	public function onPrepareContent(&$row, &$params, $page = 0) {
		$output = $this->_prepareContent($row, $params, $page);
		return $output;
	}

	public function onContentPrepare($context, &$article, &$params, $page = 0) {
		return $this->_prepareContent($article, $params, $page);
	}

	protected function _prepareContent(&$article, &$params, $page = 0) {

		if (!JFile::exists(JPATH_ADMINISTRATOR . '/components/com_zoo/config.php')) {
			return;
		}

		require_once(JPATH_ADMINISTRATOR . '/components/com_zoo/config.php');

		$this->app = App::getInstance('zoo');

		if (strpos($article->text, '{yoonique_item:') === false) {
			return true;
		}

		$regex = '/{yoonique_item:\s*(\S*)\s*element:\s*(.*?)(?:\s*config:(.*?))?}/i';
		$matches = array();
		$current_version = $this->app->zoo->version();
		$current_version = substr($current_version, 0, 3);
		if (version_compare($current_version, '2.5') >= 0) {
			$alias = $this->app->alias;
		} else {
			$alias = $this->app;
		}

		preg_match_all($regex, $article->text, $matches, PREG_SET_ORDER);

		$output = "";

		foreach ($matches as $match) {
		$id = trim($match[1], "\xC2\xA0");
			if (!is_numeric($id)) {
				$id = $alias->item->translateAliasToID($id);
			}

			if (!($id && $item = $this->app->table->item->get($id)))
				continue;

			$tpath = $this->app->table->application->get($item->application_id)->getTemplate()->getPath();
			$renderer = $this->app->renderer->create('item')->addPath(array($this->app->path->path('component.site:'), $tpath));
			$configs = $renderer->getConfig('item')->get($item->getApplication()->getGroup() . '.' . $item->getType()->id . '.full');

			if (isset($match[3]))
				$parameters = json_decode("{" . $match[3] . "}", true);
			else
				$parameters = array();

			$elements = array_merge($item->getElements(), $item->getCoreElements());

			foreach ($elements as $element) {
				foreach ($configs as $position) {
					foreach ($position as $config) {
						if ($element->identifier == $config['element']) {
							break 2;
						}
					}
				}

				$elementtype = $element->getElementType();
				$elementname = $element->getConfig()->name;
				if ($elementname == $match[2]) {
					foreach ($parameters as $key => $value) {
						if (isset($element->getConfig()->$key))
							$element->getConfig()->$key = $value;
					}
					$output = $element->render(array_merge($config, $parameters));
					break;
				}
			}
			$article->text = str_replace($match[0], $output, $article->text);
			$output = "";
		}

		return true;
	}

}
